<?php
/**
* @author Mikko Rönkkö and Mike
*/

defined( '_VALID_MOS' ) or die( 'Direct Access to this location is not allowed.' );

class conditions extends cbPluginHandler{

	function getDisplayRegistration($tab, $user, $ui) {
		global $database;

		$ret= "<script src=\"components/com_comprofiler/plugin/user/plug_conditions/funcs.js\"></script>";
		$ret.= "<script type=\"text/javascript\">";
		$ret.= "function applyConditions(rootObject){";	
		//Field init string
		$init="\n\n//INIT conditions\n\n";

		//TRIGGERS

		$database->setQuery("select c.value, c.fieldname, c.id, f.type from #__comprofiler_conditions c, #__comprofiler_fields f".
			" where c.fieldname=f.name order by c.id asc");

				
		$conditions=$database->loadObjectList();
		
		$database->setQuery("select name, type, conditionid from #__comprofiler_fields where conditionid is not null order by conditionid asc");
		$fields=$database->loadObjectList();

		$database->setQuery("select f.name, f.type, v.conditionid, v.fieldtitle from #__comprofiler_fields f, #__comprofiler_field_values v where v.conditionid is not null and v.fieldid=f.fieldid order by v.conditionid asc");
		$options=$database->loadObjectList();

		$fieldN=0;
		$optionN=0;

		//die($database->stderr(true));
		foreach($conditions as $condition){

			$condPostfix="";
			if($condition->type=="multiselect"||$condition->type=="select"){
				$condPostfix="[]";
			}

			$ret.="\nvar inputs=getInputs('".$condition->fieldname.$condPostfix."',rootObject);";
			$ret.="\nfor (var input=0;input<inputs.length;++inputs){";
			$ret.="\naddEvent(inputs[input],'change',function(e){";
			$ret.="\ne = ((e!=null) ? e : window.event);";
			$ret.="\nvar node =((e.target==null)? e.srcElement:e.target);";
 			$ret.="\nvar prefix=getPrefix(node,'".$condition->fieldname.$condPostfix."')";

			
//Fields
			while(sizeof($fields) > $fieldN and ($fields[$fieldN]->conditionid < $condition->id)){
				++$fieldN;
			}			
			while(sizeof($fields) > $fieldN and ($fields[$fieldN]->conditionid == $condition->id)){
				$fieldPostfix="";
				if($fields[$fieldN]->type=="multiselect"||$fields[$fieldN]->type=="select"){
					$fieldPostfix="[]";
				}

				$ret.="\nshowHide(document.getElementsByName(prefix+'".($fields[$fieldN]->name).$fieldPostfix.
				"')[0].parentNode.parentNode,node.value=='".$condition->value."');";
				$init.="\nvar inputs=getInputs('".($fields[$fieldN]->name).$fieldPostfix."',rootObject);";
				$init.="\nfor (var input=0;input<inputs.length;++inputs){";
				$init.="\nvar temp=getPrefix(inputs[input],'".$fields[$fieldN]->name.$fieldPostfix."');";
				$init.="\nshowHide(inputs[input].parentNode.parentNode,document.getElementsByName(temp+'".$condition->fieldname.$condPostfix."')[0].value=='".$condition->value."');}";	

				++$fieldN;
				
			}
//Options
			while(sizeof($options) > $optionN and ($options[$optionN]->conditionid < $condition->id)){
				++$optionN;
			}			
			while(sizeof($options) > $optionN and ($options[$optionN]->conditionid == $condition->id)){
				$optionPostfix="";
				if($options[$optionN]->type=="multiselect"||$options[$optionN]->type=="select"){
					$optionPostfix="[]";
				}

				$ret.="\nif(node.value=='".$condition->value."'){";
				$ret.="\nvar options=document.getElementsByName(prefix+'".($options[$optionN]->name).$optionPostfix.
				"')[0].options";
				$ret.="\noptions[options.length]=new Option('".$options[$optionN]->fieldtitle."','".$options[$optionN]->fieldtitle."',false,false);";
				$ret.="\n}else{";
				$ret.="\nvar select=document.getElementsByName(prefix+'".($options[$optionN]->name).$optionPostfix."')[0]";
				$ret.="\nremoveOption(select,'".$options[$optionN]->fieldtitle."');";
				$ret.="\n}";

				$condPostfix="";
                                if($condition->type=="multiselect"||$condition->type=="select"){
                                        $condPostfix="[]";
                                }

				
				$init.="\ninputs=getInputs('".$condition->fieldname.$condPostfix."',rootObject);";
				$init.="\nfor(input in inputs){";
				$init.="\ntemp=getPrefix(inputs[input],'".$condition->fieldname.$condPostfix."');";
				$init.="\nif(document.getElementsByName(temp+'".$condition->fieldname.$condPostfix."')[0].value!='".$condition->value."'){";

				
				$init.="\nvar select=document.getElementsByName(temp+'".($options[$optionN]->name).$optionPostfix."')[0]";
				$init.="\nremoveOption(select,'".$options[$optionN]->fieldtitle."');}}";
				++$optionN;
				
			}
			$ret.="\n}, false)};";
		}

		$ret.=$init;
		$ret.="\n}\napplyConditions(document);";
		$ret.="</script>";			
		return $ret;
	}

	function getEditTab($tab, $user, $ui) {
		global $database;

		$ret= "<script src=\"components/com_comprofiler/plugin/user/plug_conditions/funcs.js\"></script>";
		$ret.= "<script type=\"text/javascript\">";
		$ret.= "function applyConditions(rootObject){";	
		//Field init string
		$init="\n\n//INIT conditions\n\n";

		//TRIGGERS

		$database->setQuery("select c.value, c.fieldname, c.id, f.type from #__comprofiler_conditions c, #__comprofiler_fields f".
			" where c.fieldname=f.name order by c.id asc");

				
		$conditions=$database->loadObjectList();
		
		$database->setQuery("select name, type, conditionid from #__comprofiler_fields where conditionid is not null order by conditionid asc");
		$fields=$database->loadObjectList();

		$database->setQuery("select f.name, f.type, v.conditionid, v.fieldtitle from #__comprofiler_fields f, #__comprofiler_field_values v where v.conditionid is not null and v.fieldid=f.fieldid order by v.conditionid asc");
		$options=$database->loadObjectList();

		$fieldN=0;
		$optionN=0;

		//die($database->stderr(true));
		foreach($conditions as $condition){

			$condPostfix="";
			if($condition->type=="multiselect"||$condition->type=="select"){
				$condPostfix="[]";
			}

			$ret.="\nvar inputs=getInputs('".$condition->fieldname.$condPostfix."',rootObject);";
			$ret.="\nfor (var input=0;input<inputs.length;++inputs){";
			$ret.="\naddEvent(inputs[input],'change',function(e){";
			$ret.="\ne = ((e!=null) ? e : window.event);";
			$ret.="\nvar node =((e.target==null)? e.srcElement:e.target);";
 			$ret.="\nvar prefix=getPrefix(node,'".$condition->fieldname.$condPostfix."')";

			
//Fields
			while(sizeof($fields) > $fieldN and ($fields[$fieldN]->conditionid < $condition->id)){
				++$fieldN;
			}			
			while(sizeof($fields) > $fieldN and ($fields[$fieldN]->conditionid == $condition->id)){
				$fieldPostfix="";
				if($fields[$fieldN]->type=="multiselect"||$fields[$fieldN]->type=="select"){
					$fieldPostfix="[]";
				}

				$ret.="\nshowHide(document.getElementsByName(prefix+'".($fields[$fieldN]->name).$fieldPostfix.
				"')[0].parentNode.parentNode,node.value=='".$condition->value."');";
				$init.="\nvar inputs=getInputs('".($fields[$fieldN]->name).$fieldPostfix."',rootObject);";
				$init.="\nfor (var input=0;input<inputs.length;++inputs){";
				$init.="\nvar temp=getPrefix(inputs[input],'".$fields[$fieldN]->name.$fieldPostfix."');";
				$init.="\nshowHide(inputs[input].parentNode.parentNode,document.getElementsByName(temp+'".$condition->fieldname.$condPostfix."')[0].value=='".$condition->value."');}";	

				++$fieldN;
				
			}
//Options
			while(sizeof($options) > $optionN and ($options[$optionN]->conditionid < $condition->id)){
				++$optionN;
			}			
			while(sizeof($options) > $optionN and ($options[$optionN]->conditionid == $condition->id)){
				$optionPostfix="";
				if($options[$optionN]->type=="multiselect"||$options[$optionN]->type=="select"){
					$optionPostfix="[]";
				}

				$ret.="\nif(node.value=='".$condition->value."'){";
				$ret.="\nvar options=document.getElementsByName(prefix+'".($options[$optionN]->name).$optionPostfix.
				"')[0].options";
				$ret.="\noptions[options.length]=new Option('".$options[$optionN]->fieldtitle."','".$options[$optionN]->fieldtitle."',false,false);";
				$ret.="\n}else{";
				$ret.="\nvar select=document.getElementsByName(prefix+'".($options[$optionN]->name).$optionPostfix."')[0]";
				$ret.="\nremoveOption(select,'".$options[$optionN]->fieldtitle."');";
				$ret.="\n}";

				$condPostfix="";
                                if($condition->type=="multiselect"||$condition->type=="select"){
                                        $condPostfix="[]";
                                }

				
				$init.="\ninputs=getInputs('".$condition->fieldname.$condPostfix."',rootObject);";
				$init.="\nfor(input in inputs){";
				$init.="\ntemp=getPrefix(inputs[input],'".$condition->fieldname.$condPostfix."');";
				$init.="\nif(document.getElementsByName(temp+'".$condition->fieldname.$condPostfix."')[0].value!='".$condition->value."'){";

				
				$init.="\nvar select=document.getElementsByName(temp+'".($options[$optionN]->name).$optionPostfix."')[0]";
				$init.="\nremoveOption(select,'".$options[$optionN]->fieldtitle."');}}";
				++$optionN;
				
			}
			$ret.="\n}, false)};";
		}

		$ret.=$init;
		$ret.="\n}\napplyConditions(document);";
		$ret.="</script>";			
		return $ret;
	}

}
?>
